org.apache.hc.client5.http.impl.async

## Class HttpAsyncClients

- java.lang.Object
- - org.apache.hc.client5.http.impl.async.HttpAsyncClients

    public class HttpAsyncClients
    extends Object

Factory methods for `CloseableHttpAsyncClient` instances.

Since:
  5.0

### Method Summary

Methods
`static CloseableHttpAsyncClient` `createDefault()` Creates `CloseableHttpAsyncClient` instance with default configuration.
`static MinimalHttpAsyncClient` `createMinimal()` Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.
`static MinimalHttpAsyncClient` `createMinimal(AsyncClientConnectionManager connManager)` Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.
`static MinimalHttpAsyncClient` `createMinimal(org.apache.hc.core5.http.config.H1Config h1Config, org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig)` Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 transport only.
`static MinimalHttpAsyncClient` `createMinimal(org.apache.hc.core5.http2.config.H2Config h2Config, org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig)` Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/2 transport only.
`static MinimalHttpAsyncClient` `createMinimal(org.apache.hc.core5.http2.HttpVersionPolicy versionPolicy, org.apache.hc.core5.http2.config.H2Config h2Config, org.apache.hc.core5.http.config.H1Config h1Config)` Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.
`static MinimalHttpAsyncClient` `createMinimal(org.apache.hc.core5.http2.HttpVersionPolicy versionPolicy, org.apache.hc.core5.http2.config.H2Config h2Config, org.apache.hc.core5.http.config.H1Config h1Config, org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig)` Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.

`static MinimalHttpAsyncClient`

`createMinimal(org.apache.hc.core5.http2.HttpVersionPolicy versionPolicy, org.apache.hc.core5.http2.config.H2Config h2Config, org.apache.hc.core5.http.config.H1Config h1Config, org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig, AsyncClientConnectionManager connmgr)`
Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.

`static CloseableHttpAsyncClient` `createSystem()` Creates `CloseableHttpAsyncClient` instance with default configuration and system properties.
`static HttpAsyncClientBuilder` `custom()` Creates builder object for construction of custom `CloseableHttpAsyncClient` instances.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### custom

    public static HttpAsyncClientBuilder custom()

Creates builder object for construction of custom `CloseableHttpAsyncClient` instances.

#### createDefault

    public static CloseableHttpAsyncClient createDefault()

Creates `CloseableHttpAsyncClient` instance with default configuration.

#### createSystem

    public static CloseableHttpAsyncClient createSystem()

Creates `CloseableHttpAsyncClient` instance with default configuration and system properties.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal(org.apache.hc.core5.http2.HttpVersionPolicy versionPolicy,
                                       org.apache.hc.core5.http2.config.H2Config h2Config,
                                       org.apache.hc.core5.http.config.H1Config h1Config,
                                       org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig,
                                       AsyncClientConnectionManager connmgr)

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal(org.apache.hc.core5.http2.HttpVersionPolicy versionPolicy,
                                       org.apache.hc.core5.http2.config.H2Config h2Config,
                                       org.apache.hc.core5.http.config.H1Config h1Config,
                                       org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig)

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal(org.apache.hc.core5.http2.HttpVersionPolicy versionPolicy,
                                       org.apache.hc.core5.http2.config.H2Config h2Config,
                                       org.apache.hc.core5.http.config.H1Config h1Config)

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal()

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal(org.apache.hc.core5.http.config.H1Config h1Config,
                                       org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig)

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 transport only.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal(org.apache.hc.core5.http2.config.H2Config h2Config,
                                       org.apache.hc.core5.reactor.IOReactorConfig ioReactorConfig)

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/2 transport only.

#### createMinimal

    public static MinimalHttpAsyncClient createMinimal(AsyncClientConnectionManager connManager)

Creates `MinimalHttpAsyncClient` instance that provides essential HTTP/1.1 and HTTP/2 message transport only.